# Shiny Server

Shiny Server is a server program that makes [Shiny](https://rstudio.com/shiny) applications available over the web.

## Features

* Host multiple Shiny applications, each with its own URL
* Can be configured to allow any user on the system to create and deploy their own Shiny applications
* Supports non-websocket-capable browsers, like IE9
* Free and open source ([AGPLv3](http://www.gnu.org/licenses/agpl-3.0.html) license)
* Pre-built installers for select Linux distributions.

## Installing

At this time, Shiny Server can be run on Linux servers with explicit support for Ubuntu 14.04 or greater (64 bit) and CentOS/RHEL 6 (64 bit) or greater. If you are using one of these distributions, please download the pre-packaged installers from RStudio:

> [Download Shiny Server Installers](https://www.rstudio.com/products/shiny/shiny-server/). 

These installers will provide a majority of the prerequisite software and will provision all the necessary directories for you.

If you are not using one of the explicitly supported distributions, you can still use Shiny Server by building it from source, see the [instructions for building from source](https://github.com/rstudio/shiny-server/wiki/Building-Shiny-Server-from-Source).

## Configuration

Shiny Server will use the [default configuration](https://github.com/rstudio/shiny-server/blob/master/config/default.config) unless an alternate configuration is provided at `/etc/shiny-server/shiny-server.conf`. Using the default configuration, Shiny Server will look for Shiny apps in `/srv/shiny-server/` and host them on port 3838. If you plan to host your apps in this directory, you can either copy an app you've already developed to that location:

```
sudo cp -R ~/MY-APP /srv/shiny-server/
```

Or you can copy some or all of the examples provided with the Shiny package. (The location of the R library varies from system to system. You can use the command `R -e ".libPaths()" --quiet` to print the directory of the R library.) For instance, on Ubuntu, you could execute `cp -R /usr/local/lib/R/site-library/shiny/examples/* /srv/shiny-server/`.

Now start a web browser and point it to `http://<hostname>:3838/APP_NAME/`

**If the browser is not able to connect to the server, configure your server's firewall to allow inbound TCP connections on port 3838.**

To customize any of the above, or to explore the other ways Shiny Server can host Shiny apps, see the [Shiny Server Configuration Reference](https://rstudio.github.io/shiny-server/latest/#configuration-settings) for details on the various ways Shiny Server can be configured.

## Documentation & Contact & Support

See [the Administrator's Guide to Shiny Server](https://rstudio.github.io/shiny-server/latest/) for more complete documentation regarding the setup and management of Shiny Server.

Please direct questions to the [Shiny Community discussion board](https://community.rstudio.com/c/shiny). If you're interested in Professional Support, please look at our commercial [Shiny Server Pro](https://www.rstudio.com/products/shiny-server-pro/) product.

Docker containers for Shiny Server development
==============================================

The `ubuntu16.04/` directory contains a Dockerfile for creating an Docker image that can be used for Shiny Server development.

**Note:** Any files created will have UID 1000. This UID is generally the same as the first user added on most Linux hosts, but not for macOS hosts. This may cause problems with creating or modifying any files. Hopefully, Docker will provide a good solution for this in the future.


## Building the image

To build the Docker image, start in the shiny-server directory and run:

```sh
docker build -t ss-devel docker/ubuntu16.04/
```

## Running the image

```sh
docker run --rm -ti -p 3838:3838 -v $(pwd):/shiny-server --name ssd ss-devel
```

This will start a shell as the `docker` user. This user can `sudo` without a password.

Shiny Server has already been installed in the image, so various system files, directories, and the `shiny` user will already exist.

Once started, you will need to build Shiny Server once:

```sh
cd /shiny-server
packaging/make-package.sh
```

Once this is done, you can start `shiny-server` directly from the development directory. You can also modify the source code and restart `shiny-server`.

```sh
cd /shiny-server
sudo bin/shiny-server
```

You can then visit the server at http://localhost:3838/.

After making changes, you may want to rebuild the package and reinstall:

```sh
packaging/make-package.sh

# Might need to adjust the version
sudo dpkg -i packaging/build/shiny-server-1.4.4.0-amd64.deb
```


## Notes

If you want to mount the shiny source at `/shiny` and be able to install it, start the container with `-v $(pwd)/../shiny:/shiny` (assuming it's a sibling directory of `shiny-server/`):

```sh
# Start in shiny-server directory
docker run --rm -ti -p 3838:3838 \
    -v $(pwd):/shiny-server \
    -v $(pwd)/../shiny:/shiny \
    --name ssd ss-devel

# Then, in another terminal, you can install Shiny:
docker exec -ti ssd Rscript -e 'devtools::install("/shiny")'
```


If you need to enter a running container and inspect it or install software on it, run:

```
docker exec -ti ssd /bin/bash
```


If you want to rebuild the docker image without any cached layers, you can delete the `ss-devel` image and rebuild, or you can build with the `--no-cache` flag. The image can be deleted with:

```sh
# Remove the image and rebuild
docker rmi ss-devel
docker build -t ss-devel docker/ubuntu16.04/

# Or build with no cache
docker build --no-cache -t ss-devel docker/ubuntu16.04/
```

Spin up the NFS server first:

```
vagrant up nfs
```

Then you can bring up the Shiny Server machine:

```
vagrant up sso
```

At this point, you should have a Shiny Server instance which mounts the directory `/home/shiny` over NFS with `root_squash` which can be used to test user_dirs over NFS with root_squash.

Access the applications with URLs like this: 

http://192.168.42.101:3838/shiny/01_hello

library(shiny)

# Define server logic required to draw a histogram
shinyServer(function(input, output) {

  # Expression that generates a histogram. The expression is
  # wrapped in a call to renderPlot to indicate that:
  #
  #  1) It is "reactive" and therefore should be automatically
  #     re-executed when inputs change
  #  2) Its output type is a plot

  output$distPlot <- renderPlot({
    x    <- faithful[, 2]  # Old Faithful Geyser data
    bins <- seq(min(x), max(x), length.out = input$bins + 1)

    # draw the histogram with the specified number of bins
    hist(x, breaks = bins, col = 'darkgray', border = 'white')
  })

})

library(ggplot2)
library(reshape2)
library(shiny)


memlog <- file.choose()
data <- reactiveFileReader(300, NULL, memlog, read.csv)

runApp(list(ui = basicPage(
    plotOutput("plot")
  ),
  server = function(input, output, session) {
    output$plot <- renderPlot({
      p <- ggplot(data = data(), aes(x = 1:nrow(data())))
      p <- p + geom_line(aes(y = rss), color = 'red')
      p <- p + geom_line(aes(y = heapTotal))
      p <- p + geom_line(aes(y = heapUsed))
      p <- p + geom_smooth(aes(y = rss), method = "loess")
      print(p)
    })
  }
), launch.browser = rstudio::viewer)

library(shiny)

# Define UI for application that plots random distributions 
shinyUI(pageWithSidebar(
  
  # Application title
  headerPanel("It's Alive!"),
  
  # Sidebar with a slider input for number of observations
  sidebarPanel(
    sliderInput("bins",
                  "Number of bins:",
                  min = 1,
                  max = 50,
                  value = 30)
  ),
  
  # Show a plot of the generated distribution
  mainPanel(
    plotOutput("distPlot", height=250)
  )
))

#
# SockJSAdapter.R
#
# Copyright (C) 2009-17 by RStudio, Inc.
#
# This program is licensed to you under the terms of version 3 of the
# GNU Affero General Public License. This program is distributed WITHOUT
# ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
# AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
#

local({
  dir_exists <- function(path) {
    utils::file_test('-d', path)
  }

  # Read config directives from stdin and put them in the environment.
  fd = file('stdin')
  input <- readLines(fd)
  input <- jsonlite::fromJSON(input, simplifyVector = TRUE)
  Sys.setenv(
    SHINY_APP=input$appDir,
    SHINY_PORT=input$port,
    SHINY_GAID=input$gaTrackingId,
    SHINY_SHARED_SECRET=input$sharedSecret,
    SHINY_SERVER_VERSION=input$shinyServerVersion,
    WORKER_ID=input$workerId,
    SHINY_MODE=input$mode,
    RSTUDIO_PANDOC=input$pandocPath,
    LOG_FILE=input$logFilePath
  )

  if (!identical(Sys.getenv('LOG_FILE'), "")){
    # Redirect stderr to the given path.
    message("Redirecting to ", Sys.getenv("LOG_FILE"))
    errFile <- file(Sys.getenv('LOG_FILE'), "a")
    sink(errFile, type="message")
  }

  disableProtocols <- input$disableProtocols
  if (length(disableProtocols) == 0) {
    disableProtocols <- ""
  } else {
    disableProtocols <- paste('"', disableProtocols, '"', sep = '', collapse = ',')
  }
  reconnect <- if (identical("true", tolower(input$reconnect))) "true" else "false"
  options(shiny.sanitize.errors = identical("true", tolower(input$sanitizeErrors)))

  # Top-level bookmarking directory (for all users)
  bookmarkStateDir <- input$bookmarkStateDir
  # Name of bookmark directory for this app. Uses the basename of the path and
  # appends a hash of the full path. So if the path is "/path/to/myApp", the
  # result is "myApp-6fbdbedc4c99d052b538b2bfc3c96550".
  bookmarkAppDir <- paste0(
    basename(input$appDir), "-",
    digest::digest(input$appDir, algo = "md5", serialize = FALSE)
  )

  if (!is.null(asNamespace("shiny")$shinyOptions)) {
    if (nchar(bookmarkStateDir) > 0) {
      shiny::shinyOptions(
        save.interface = function(id, callback) {
          username <- Sys.info()[["effective_user"]]
          dirname <- file.path(bookmarkStateDir, username, bookmarkAppDir, id)
          if (dir_exists(dirname)) {
            stop("Directory ", dirname, " already exists")
          } else {
            dir.create(dirname, recursive = TRUE, mode = "0700")
            callback(dirname)
          }
        },
        load.interface = function(id, callback) {
          username <- Sys.info()[["effective_user"]]
          dirname <- file.path(bookmarkStateDir, username, bookmarkAppDir, id)
          if (!dir_exists(dirname)) {
            stop("Session ", id, " not found")
          } else {
            callback(dirname)
          }
        }
      )
    } else {
      shiny::shinyOptions(
        save.interface = function(id, callback) {
          stop("This server is not configured for saving sessions to disk.")
        },
        load.interface = function(id, callback) {
          stop("This server is not configured for saving sessions to disk.")
        }
      )
    }
  } 
  close(fd)

  MIN_R_VERSION <- "2.15.1"
  MIN_SHINY_VERSION <- "0.7.0"
  MIN_RMARKDOWN_VERSION <- "0.1.90"
  MIN_KNITR_VERSION <- "1.5.32"

  # We can have a more stringent requirement for the Shiny version when using
  # rmarkdown
  MIN_SHINY_RMARKDOWN_VERSION <- "0.9.1.9005"

  options(shiny.sharedSecret = Sys.getenv('SHINY_SHARED_SECRET'))

  rVer <- as.character(getRversion());
  shinyVer <- tryCatch({as.character(packageVersion("shiny"))},
      error=function(e){"0.0.0"});

  markdownVer <- tryCatch({as.character(packageVersion("rmarkdown"))},
      error=function(e){"0.0.0"});

  knitrVer <- tryCatch({as.character(packageVersion("knitr"))},
      error=function(e){"0.0.0"});

  cat("shiny_launch_info: ")
  cat(jsonlite::toJSON(pretty = FALSE, auto_unbox = TRUE, list(
    pid = Sys.getpid(),
    versions = list(
      r = rVer,
      shiny = shinyVer,
      rmarkdown = markdownVer,
      knitr = knitrVer
    )
  )))
  cat("\n")

  if (compareVersion(MIN_R_VERSION,rVer)>0){
    # R is out of date
    stop(paste("R version '", rVer, "' found. Shiny Server requires at least '",
        MIN_R_VERSION, "'."), sep="")
  }
  if (compareVersion(MIN_SHINY_VERSION,shinyVer)>0){
    if (shinyVer == "0.0.0"){
      # Shiny not found
      stop(paste("The Shiny package was not found in the library. Ensure that ",
        "Shiny is installed and is available in the Library of the ",
        "user you're running this application as.", sep="\n"))
    } else{
      # Shiny is out of date
      stop(paste("Shiny version '", shinyVer, "' found. Shiny Server requires at least '",
          MIN_SHINY_VERSION, "'."), sep="")      
    }  
  }

  mode <- Sys.getenv('SHINY_MODE')
  # Trying to use rmd, verify package.
  if (identical(mode, "rmd")){
    if (compareVersion(MIN_RMARKDOWN_VERSION,markdownVer)>0){
      if (markdownVer == "0.0.0"){
        # rmarkdown not found
        stop(paste("You are attempting to load an rmarkdown file, but the ",
          "rmarkdown package was not found in the library. Ensure that ",
          "rmarkdown is installed and is available in the Library of the ",
          "user you're running this application as.", sep="\n"))
      } else{
        # rmarkdown is out of date
        stop(paste("rmarkdown version '", markdownVer, "' found. Shiny Server requires at least '",
            MIN_RMARKDOWN_VERSION, "'."), sep="")
      } 
    }
    if (compareVersion(MIN_SHINY_RMARKDOWN_VERSION,shinyVer)>0){
      # We know it's installed b/c we got to this code chunk, so it's outdated.
      stop(paste("Shiny version '", shinyVer, "' found. Shiny Server requires at least '",
          MIN_SHINY_RMARKDOWN_VERSION, "' to use with the rmarkdown package."), sep="")
    }
    if (compareVersion(MIN_KNITR_VERSION,knitrVer)>0){
      # We know it's installed b/c we got to this code chunk, so it's outdated.
      stop(paste("knitr version '", knitrVer, "' found. Shiny Server requires at least '",
          MIN_KNITR_VERSION, "' to use with the rmarkdown package."), sep="")
    }
  }

  library(shiny)

  if (exists("setServerInfo", envir=asNamespace("shiny"))) {
    shiny:::setServerInfo(shinyServer = TRUE, 
      version = Sys.getenv("SHINY_SERVER_VERSION"), 
      edition = "OS")
  }

   gaTrackingCode <- ''
   if (nzchar(Sys.getenv('SHINY_GAID'))) {
      gaTrackingCode <- HTML(sprintf("<script type=\"text/javascript\">

  var _gaq = _gaq || [];
  _gaq.push(['_setAccount', '%s']);
  _gaq.push(['_trackPageview']);

  (function() {
    var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
    ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
    var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
  })();

</script>", Sys.getenv('SHINY_GAID')))
   }

   inject <- paste(
      tags$script(src='__assets__/sockjs.min.js'),
      tags$script(src='__assets__/shiny-server-client.min.js'),
      tags$script(
        sprintf("preShinyInit({reconnect:%s,disableProtocols:[%s]});",
          reconnect, disableProtocols
        )
      ),
      tags$link(rel='stylesheet', type='text/css', href='__assets__/shiny-server.css'),
      gaTrackingCode,
      HTML("</head>"),
      sep="\n"
   )

   filter <- function(...) {
      # The signature of filter functions changed between Shiny 0.4.0 and
      # 0.4.1; previously the parameters were (ws, headers, response) and
      # after they became (request, response). To work with both types, we
      # just grab the last argument.
      response <- list(...)[[length(list(...))]]

      if (response$status < 200 || response$status > 300) return(response)

      # Don't break responses that use httpuv's file-based bodies.
      if ('file' %in% names(response$content))
         return(response)
                                                
      if (!grepl("^text/html\\b", response$content_type, perl=T))
         return(response)

      # HTML files served from static handler are raw. Convert to char so we
      # can inject our head content.
      if (is.raw(response$content))
         response$content <- rawToChar(response$content)

      response$content <- sub("</head>", inject, response$content, 
         ignore.case=T)
      return(response)
   }
   options(shiny.http.response.filter=filter)
})

# Port can be either a TCP port number, in which case we need to cast to
# integer; or else a Unix domain socket path, in which case we need to
# leave it as a string
port <- suppressWarnings(as.integer(Sys.getenv('SHINY_PORT')))
if (is.na(port)) {
  port <- Sys.getenv('SHINY_PORT')
  attr(port, 'mask') <- strtoi('0077', 8)
}
cat("==END==\n")

if (identical(Sys.getenv('SHINY_MODE'), "shiny")){
  runApp(Sys.getenv('SHINY_APP'),port=port,launch.browser=FALSE)
} else if (identical(Sys.getenv('SHINY_MODE'), "rmd")){
  # If we might be rendering Quarto docs, it's important to suppress the
  # prerender step (see https://github.com/rstudio/shiny-server/pull/531)
  if (length(list.files(Sys.getenv('SHINY_APP'), pattern = "*.qmd")) > 0) {
    Sys.setenv(RMARKDOWN_RUN_PRERENDER = "0")
  }
  library(rmarkdown)
  rmarkdown::run(file=NULL, dir=Sys.getenv('SHINY_APP'),
    shiny_args=list(port=port,launch.browser=FALSE), auto_reload=FALSE)
} else{
  stop(paste("Unclear Shiny mode:", Sys.getenv('SHINY_MODE')))
}

library(shiny)

# Define server logic required to generate and plot a random distribution
shinyServer(function(input, output) {
   
  # Expression that generates a plot of the distribution. The expression
  # is wrapped in a call to renderPlot to indicate that:
  #
  #  1) It is "reactive" and therefore should be automatically 
  #     re-executed when inputs change
  #  2) Its output type is a plot 
  #
  output$distPlot <- renderPlot({
        
    # generate an rnorm distribution and plot it
    dist <- rnorm(input$obs)
    hist(dist)
  })
  
})

library(shiny)

# Define UI for application that plots random distributions 
shinyUI(pageWithSidebar(
  
  # Application title
  headerPanel("Hello Shiny!"),
  
  # Sidebar with a slider input for number of observations
  sidebarPanel(
    sliderInput("obs", 
                "Number of observations:", 
                min = 1, 
                max = 1000, 
                value = 500)
  ),
  
  # Show a plot of the generated distribution
  mainPanel(
    plotOutput("distPlot")
  )
))

echo "deb http://cran.rstudio.com/bin/linux/ubuntu precise/" >> /etc/apt/sources.list

apt-get update

# --force-yes to handle the un-verified deb
apt-get install r-base-dev r-base -y --force-yes

wget https://s3.amazonaws.com/rstudio-shiny-server-os-build/ubuntu-12.04/x86_64/VERSION -O "version.txt"
VERSION=`cat version.txt`

# Install the latest SSO build
wget "https://s3.amazonaws.com/rstudio-shiny-server-os-build/ubuntu-12.04/x86_64/shiny-server-$VERSION-amd64.deb" -O ss-latest.deb

apt-get install gdebi -y
gdebi -n ss-latest.deb

# R is too old for CRAN's latest Rcpp
wget http://cran.r-project.org/src/contrib/Archive/Rcpp/Rcpp_0.10.5.tar.gz -O Rcpp_0.10.5.tar.gz
R CMD INSTALL Rcpp_0.10.5.tar.gz

R -e "install.packages('shiny', repos='http://cran.rstudio.com/')"

cp -R /usr/local/lib/R/site-library/shiny/examples/* /srv/shiny-server/

#!/bin/bash

set -e

if [ $# -ne "2" ]; then
  echo "You must provide two arguments: the name of the log file and the mode"
  exit 1;
fi

LOGDIR=$(dirname "$1")

# Create directory if necessary. Will fail if it's a file.
echo "Creating directory $LOGDIR if it doesn't exist."
mkdir -p "$LOGDIR"

# Set desired mode
touch "$1"
chmod "$2" "$1"

#!/usr/bin/env bash

set -e

# connect to NFS server already running on the primary machine
apt-get install -y nfs-common
mkdir -p /home/shiny
echo "192.168.42.102:/home/shiny /home/shiny/ nfs rsize=8192,wsize=8192,timeo=14,intr" >> /etc/fstab
mount -a 

# Install SSP to get the shiny user and config files, etc.
wget -q https://s3.amazonaws.com/rstudio-shiny-server-os-build/ubuntu-14.04/x86_64/VERSION -O "version.txt"
VERSION=`cat version.txt`

apt-get install -y gdebi-core

# Install the latest SSP build
wget -q "https://s3.amazonaws.com/rstudio-shiny-server-os-build/ubuntu-14.04/x86_64/shiny-server-$VERSION-amd64.deb" -O ssp-latest.deb
gdebi -n ssp-latest.deb

R -e "install.packages('shiny', repos='http://cran.rstudio.com/')"                 
                                                                                   
cp -R /usr/local/lib/R/site-library/shiny/examples/* /srv/shiny-server/

cp /shiny-server/vagrant/nfs/shiny-server.conf /etc/shiny-server/shiny-server.conf
systemctl restart shiny-server

#!/usr/bin/env bash

set -e

# add repo for R 
apt-key adv --keyserver keyserver.ubuntu.com --recv-keys 0x51716619e084dab9
echo "deb https://cran.rstudio.com/bin/linux/ubuntu xenial/" >> /etc/apt/sources.list

# bring apt database up to date with R packages
apt-get update

# install R
apt-get install -y --force-yes r-base r-base-dev

# install minimal packages needed to run bootstrap scripts
apt-get install -y unzip
apt-get install -y git
apt-get install -y g++
apt-get install -y wget

# install packages needed to build and run devtools
apt-get install -y libssh2-1-dev
apt-get install -y curl 
apt-get install -y libcurl4-openssl-dev

#!/usr/bin/env bash

set -e

CMAKE=cmake
if hash cmake28 2>/dev/null; then
   CMAKE=cmake28
fi

cd "$(dirname $0)"

# See if "shiny" user exists
if id -u shiny >/dev/null 2>&1;
then
   echo User "shiny" already exists
else
   echo Creating user "shiny"
   sudo useradd -r -m shiny
fi

sudo mkdir -p /var/log/shiny-server
sudo mkdir -p /srv/shiny-server

# Log dir must be writable by "shiny" user
sudo chown shiny:shiny /var/log/shiny-server

mkdir -p build
(cd build && "$CMAKE" ../.. && make)

(cd .. && bin/npm install)

#!/bin/bash

set -e

if [ "$1" == "" ] || [ "$2" == "" ]; then
  echo "Usage: is-merge.sh <source-ref> <target-ref>" 1>&2
  exit 127
fi

BASE=`git merge-base $1 $2`
REF=`git rev-parse $1`
if [ "$BASE" != "$REF" ]; then
  COUNT=`git log $BASE..$REF --pretty=oneline | wc -l`
  echo "$2 is $COUNT commit(s) behind $1" 1>&2
  exit 1
fi

# Enable EPEL
rpm -Uvh http://mirror.pnl.gov/epel/7/x86_64/e/epel-release-7-2.noarch.rpm

# On this minimal install, we need wget
yum install wget -y

# Install R
yum install R -y

wget https://s3.amazonaws.com/rstudio-shiny-server-os-build/centos-6.3/x86_64/VERSION -O "version.txt"
VERSION=`cat version.txt`

# Install the latest SS build
wget "https://s3.amazonaws.com/rstudio-shiny-server-os-build/centos-6.3/x86_64/shiny-server-$VERSION-rh6-x86_64.rpm" -O ss-latest.rpm
yum install --nogpgcheck ss-latest.rpm -y

echo "password" | /opt/shiny-server/bin/sspasswd /etc/shiny-server/passwd "admin"

sudo su - \
    -c "R -e \"install.packages('shiny', repos='http://cran.rstudio.com/')\""

sudo cp -R /usr/lib64/R/library/shiny/examples/* /srv/shiny-server/

systemctl disable firewalld 
systemctl stop firewalld
sed -i 's/enforcing/disabled/g' /etc/selinux/config

#!/usr/bin/env bash

# Create Shiny user
useradd -r -m shiny
mkdir /home/shiny/ShinyApps/
chown -R shiny:shiny /home/shiny
chmod 755 -R /home/shiny

# install NFS server and export user home directories
apt-get install -y nfs-kernel-server
echo "/home/shiny   *(rw,sync,root_squash)" >> /etc/exports
service nfs-kernel-server restart

# Install apps in Shiny user's personal dir
git clone https://github.com/rstudio/shiny.git
cp -R shiny/inst/examples/* /home/shiny/ShinyApps/

echo "deb http://cran.rstudio.com/bin/linux/ubuntu precise/" >> /etc/apt/sources.list

apt-get update

# --force-yes to handle the un-verified deb
apt-get install r-base-dev r-base -y --force-yes

apt-get install gdebi git gcc g++ -y

# R is too old for CRAN's latest Rcpp
wget http://cran.r-project.org/src/contrib/Archive/Rcpp/Rcpp_0.10.5.tar.gz -O Rcpp_0.10.5.tar.gz
R CMD INSTALL Rcpp_0.10.5.tar.gz

R -e "install.packages('shiny', repos='http://cran.rstudio.com/')"

mkdir -p /srv/shiny-server

cp -R /usr/local/lib/R/site-library/shiny/examples/* /srv/shiny-server/

# Get and build cmake
wget http://www.cmake.org/files/v2.8/cmake-2.8.11.2.tar.gz
tar xzf cmake-2.8.11.2.tar.gz
cd cmake-2.8.11.2
./configure
make
make install

#!/bin/bash

set -e

# Get the shiny-server directory
ROOT="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && cd .. && pwd )"

if [ $# -eq 0 ]
then
  echo "No test config name supplied, using \"testapps\"" >&2
  TEST="testapps"
else
  # The name of the config template in test/configs (e.g. "testapps" for testapps.config.in)
  TEST="$1"
  shift
fi

CONFIG_IN="$ROOT/test/configs/$TEST.config.in"
mkdir -p /tmp/shiny-server-test
CONFIG_OUT="/tmp/shiny-server-test/$TEST.config"
(sed -e "s/\$USER/$USER/g" | sed -e "s/\$ROOT/$(echo $ROOT | sed -e 's/[\/&]/\\&/g')/g") < "$CONFIG_IN" > "$CONFIG_OUT"

"$ROOT/bin/shiny-server" $CONFIG_OUT $@

echo "deb http://cran.rstudio.com/bin/linux/ubuntu trusty/" >> /etc/apt/sources.list

apt-get update

# --force-yes to handle the un-verified deb
apt-get install r-base-dev r-base -y --force-yes

wget https://s3.amazonaws.com/rstudio-shiny-server-os-build/ubuntu-12.04/x86_64/VERSION -O "version.txt"
VERSION=`cat version.txt`

# Install the latest SSO build
wget "https://s3.amazonaws.com/rstudio-shiny-server-os-build/ubuntu-12.04/x86_64/shiny-server-$VERSION-amd64.deb" -O ss-latest.deb

apt-get install gdebi -y
gdebi -n ss-latest.deb

# R is too old for CRAN's latest Rcpp
wget http://cran.r-project.org/src/contrib/Archive/Rcpp/Rcpp_0.10.5.tar.gz -O Rcpp_0.10.5.tar.gz
R CMD INSTALL Rcpp_0.10.5.tar.gz

R -e "install.packages('shiny', repos='http://cran.rstudio.com/')"

cp -R /usr/local/lib/R/site-library/shiny/examples/* /srv/shiny-server/

#!/usr/bin/env bash

if [ $# -eq 0 ]; then
    echo "publish-build.sh: utility for adding builds to the latest builds site."
    echo ""
    echo "Creates, commits, and pushes a Markdown file containing the specified build metadata."
    echo ""
    echo "Arguments:"
    echo ""
    echo "--platform  The Linux platform. Example: centos7"
    echo ""
    echo "--url       A URL to a location where the build can be downloaded. Example:"
    echo "            https://s3.amazonaws.com/rstudio-shiny-server-os-build/ubuntu-14.04/x86_64/shiny-server-1.5.18.974-amd64.deb"
    echo ""
    echo "--file      A path to a local copy of the build file. Example:"
    echo "            /tmp/shiny-server-1.5.18.974-amd64.deb"
    echo ""
    echo "--pat       The Github Personal Access Token (PAT) to be used to authorize the commit."
    echo "            May be specified in the environment variable GITHUB_PAT instead."
    exit 0
fi

# abort on error
set -e

# List of arguments
ARGUMENT_LIST=(
    "platform"
    "url"
    "file"
    "pat"
)

# Parse arguments with getopt
opts=$(getopt \
    --longoptions "$(printf "%s:," "${ARGUMENT_LIST[@]}")" \
    --name "$(basename "$0")" \
    --options "" \
    -- "$@"
)

# Apply to variables
while [[ $# -gt 0 ]]; do
    case "$1" in
        --platform)
            platform=$2
            shift 2
            ;;

        --url)
            url=$2
            shift 2
            ;;

        --file)
            file=$2
            shift 2
            ;;

        --pat)
            pat=$2
            shift 2
            ;;

        *)
            break
            ;;
    esac
done

if [ -z "$platform" ]; then
    echo "Platform not set; specify a platform with --platform. Example: --platform redhat8"
    exit 1
fi

if [ -z "$url" ]; then
    echo "URL not set; specify a build with --url. Example: --url https:/s3.amazonaws.com/rstudio-ide-build/desktop/windows/RStudio-pro.exe"
    exit 1
fi

if [ -z "$file" ]; then
    echo "File not set; specify a file with --file. Example: --file /tmp/RStudio-pro.exe"
    exit 1
fi

if [ -z "$pat" ]; then
    if [ -z "$GITHUB_PAT" ]; then
        echo "Github Personal Access Token (PAT) not set; specify a PAT with --pat or the GITHUB_PAT environment variable."
        exit 1
    else
        # PAT supplied in environment variable; promote to local
        pat="$GITHUB_PAT"
    fi
fi

# Determine file size
size=$(wc -c $file | awk '{print $1}')

# Determine file SHA256 sum
if [[ "$OSTYPE" == "darwin"* ]]; then
  sha256=$(shasum -a 256 $file | awk '{print $1}')
else
  sha256=$(sha256sum $file | awk '{print $1}')
fi

# Form ISO 8601 timestamp
timestamp=$(date +"%Y-%m-%dT%H:%M:%S%z")

# Extract packaging version
root="$( cd -- "$( dirname -- "${BASH_SOURCE[0]}" )" &> /dev/null && cd ../.. && pwd )"
version="$(cat "$root/packaging/build/VERSION")"

# Determine which product is being built by checking for the overlay make script
if [[ -f "$root/CMakeOverlay.txt" ]]; then
  product="professional"
else
  product="open-source"
fi

# Determine commit (use local hash)
pushd $root
commit=$(git rev-parse HEAD)
popd

# Escape + characters in URL (for versioning)
url=$(echo $url | sed -e 's/+/%2B/g')

# Create version stem. This is a very file-safe version of the version: first
# we replace non-alphanumerics with dashes, then collapse multiple dashes to a
# single dash.
version_stem=$(echo $version | sed -e 's/[^a-zA-Z0-9-]/-/g' | sed -e 's/--*/-/g')

# Create "branch" name. For Shiny Server this is the major and minor release
# version, so parse the full version number to extract the first two
# components.
old_ifs="$IFS"
IFS='.' read -ra components <<< "$version"
IFS="$old_ifs"
branch="${components[0]}.${components[1]}"

filename=$(basename $file)

md_contents="---
type: build
date: $timestamp
link: \"$url\"
filename: \"$filename\"
sha256: \"$sha256\"
channel: Daily
version: \"$version\"
commit: \"$commit\"
size: $size
---
"

echo "Creating $branch/$product/$platform/$version_stem.md..."
echo "$md_contents"
if [[ "$OSTYPE" == "darwin"* ]]; then
  base64_contents=$(echo "$md_contents" | base64 --break=0)
else
  base64_contents=$(echo "$md_contents" | base64 --wrap=0)
fi

payload="{\"message\":\"Add Shiny Server $product build $version for $platform\",\"content\":\"$base64_contents\"}"
echo "Sending to Github: $payload"

curl \
  -X PUT \
  -H "Accept: application/vnd.github.v3+json" \
  -H "Authorization: token $pat" \
  "https://api.github.com/repos/rstudio/latest-builds/contents/content/shiny-server/$branch/$product/$platform/$version_stem.md" \
  -d "$payload"

# This box didn't include root in 'sudoers', so any command with 'sudo' would fail 
# (since it runs as root). Add root to approved sudoers list so it's not a problem.
echo "root            ALL=(ALL)               NOPASSWD: ALL" >> /etc/sudoers

# IPTables is enabled on this box by default. Stop.
sudo /etc/init.d/iptables stop
sudo chkconfig iptables off

# Enable EPEL
rpm -Uvh http://download.fedoraproject.org/pub/epel/6/x86_64/epel-release-6-8.noarch.rpm

# Install R
yum install R -y

wget https://s3.amazonaws.com/rstudio-shiny-server-os-build/centos-6.3/x86_64/VERSION -O "version.txt"
VERSION=`cat version.txt`

# Install the latest SSP build
wget "https://s3.amazonaws.com/rstudio-shiny-server-os-build/centos-6.3/x86_64/shiny-server-$VERSION-x86_64.rpm" -O ss-latest.rpm
yum install --nogpgcheck ss-latest.rpm -y

sudo su - \
    -c "R -e \"install.packages('shiny', repos='http://cran.rstudio.com/')\""

sudo cp -R /usr/lib64/R/library/shiny/examples/* /srv/shiny-server/

#!/usr/bin/env bash

set -e
set -x

# This is needed for CentOS5/6 Jenkins workers to bootstrap a newer gcc toolchain.
cd "$(dirname $0)"

if (which scl && scl -l | grep -q devtoolset-11);
then
	scl enable devtoolset-11 ./make-package.sh
else
	CC=gcc CXX=g++ ./make-package.sh "$@"
fi

if [[ $(git diff --stat) != '' ]]; then
  echo "Repo is dirty, possibly tsc output was not checked in?" >&2
	git status >&2
	exit 1
fi

#!/usr/bin/env bash

set -e

# Find the relevant checksum from:
# https://nodejs.org/dist/v{VERSION}/SHASUMS256.txt
# The node-v{VERSION}-linux-x64.tar.xz checksum is the one we need.
NODE_SHA256=de2c694e7081c37022817d27a65b02f69ecf4c49699d65585e8e24431b7bc920

cd $(dirname $0)
cd ../..

NODE_VERSION=$(cat .nvmrc)

check_node_needed () {
  if [ -x ext/node/bin/node ]
  then
    local CURRENT_NODE_VERSION=$(ext/node/bin/node --version 2>/dev/null)
    if [[ "$CURRENT_NODE_VERSION" == "$NODE_VERSION" ]]
    then
      echo "Node $NODE_VERSION is already installed, skipping" >&2
      exit 0
    fi
  fi
}

verify_checksum () {
  local FILE=$1
  local EXPECTED_CHECKSUM=$2

  local ACTUAL_CHECKSUM=$(sha256sum "$FILE")
  [[ "$EXPECTED_CHECKSUM  $FILE" != "$ACTUAL_CHECKSUM" ]]
}

download_node () {
  local NODE_FILENAME="node-${NODE_VERSION}-linux-x64.tar.xz"
  local NODE_URL="https://nodejs.org/dist/${NODE_VERSION}/${NODE_FILENAME}"
  local NODE_ARCHIVE_DEST="/tmp/${NODE_FILENAME}"
  echo "Downloading Node ${NODE_VERSION} from ${NODE_URL}"

  wget -O "$NODE_ARCHIVE_DEST" "$NODE_URL"
  if verify_checksum "$NODE_ARCHIVE_DEST" "$NODE_SHA256"
  then
    echo "Checksum failed!" >&2
    exit 1
  fi

  rm -rf ext/node
  mkdir -p ext/node
  echo "Extracting ${NODE_FILENAME}"
  tar xf "${NODE_ARCHIVE_DEST}" --strip-components=1 -C "ext/node"

  # Clean up temp file
  rm "${NODE_ARCHIVE_DEST}"

  cp ext/node/bin/node ext/node/bin/shiny-server
  rm ext/node/bin/npm
}

check_node_needed
download_node

#!/usr/bin/env bash

set -e
set -x

env

GENERATOR="$1"
if [ "$GENERATOR" == "" ]
then
	if [ -f /etc/debian_version ]; then
		GENERATOR=DEB
	fi
	if [ -f /etc/redhat-release ]; then
		GENERATOR=RPM
	fi
fi

if [ "$GENERATOR" != "DEB" -a "$GENERATOR" != "RPM" ]
then
	echo "Usage: make-package.sh [DEB|RPM]"
	exit 1
fi

if [ "$CMAKE" == "" ]
then
	CMAKE="cmake"
	if which cmake3
	then
		CMAKE="cmake3"
	fi
fi

if [ "$CPACK" == "" ]
then
	CPACK="cpack"
	if which cpack3
	then
		CPACK="cpack3"
	fi
fi

DIR=`dirname $0`
cd "$DIR"
DIR=`pwd`
# Add node, etc. to the path
PATH=$DIR/../bin:$PATH
mkdir -p build
cd build
"$CMAKE" -DCMAKE_INSTALL_PREFIX=/opt ../..
make

# START: building in project root --------------------------
pushd ../..

./external/node/install-node.sh

# Install all dependencies and devDependencies--latter needed for `npm run build`
./bin/npm install
./bin/npm run build

# Remove devDependencies in preparation for building the installer
./bin/npm install --only=production

popd
# END: building in project root ----------------------------

"$CPACK" -G "$GENERATOR"

# Now that installer is built, install the devDependencies as well
(cd ../.. && ./bin/npm install)

---
title: "Shiny Doc"
output: html_document
runtime: shiny
---

```{r, echo=FALSE}
shinyApp(
  
  ui = fluidPage(
    selectInput("region", "Region:", 
                choices = colnames(WorldPhones)),
    plotOutput("phonePlot", height=270)
  ),
  
  server = function(input, output) {
    output$phonePlot <- renderPlot({
      barplot(WorldPhones[,input$region]*1000, 
              ylab = "Number of Telephones", xlab = "Year")
    })
  },
  
  options = list(height = 345)
)
```
